#!c:/webpage/perl/bin/perl -w

# todo: replace /$_ =~m/InitGame: \\(.+)$/) with / /

#use strict;
use DBI();

#Change the following
my $logpipe = 'c:\program files\quake iii arena\seals\games.log'; # enter the path to your SEALS logfile here
my $database = 'sealstats';
my $username = 'root'; # enter your MYSQL username here
my $password = ''; # enter your MYSQL password here
my $hostname = 'localhost'; # enter the Hostname of your MYSQL server here
my $version = '2.0';
my $nscoversion = 'seals-1.5';

my $rstat = '1'; # Allows ability to check stats in game, through use of rcon. [Untested]
  my $q3server = '127.0.0.1';
  my $q3port = '27960';
  my $q3rcon = 't00thp4st3'; 

# You should not need to change anything below here...

my $dbh = DBI->connect("DBI:mysql:$database:$hostname:", "$username", "$password", { RaiseError => 1, AutoCommit => 1 });

my $select_player = $dbh->prepare("SELECT * FROM summary_table WHERE player = ?");
my $select_player_detailed = $dbh->prepare("SELECT * FROM detailed_table WHERE killer = ? && killee = ?");
my $new_player = $dbh->prepare("INSERT INTO summary_table (player,skill) VALUES (?,?)");
my $select_rank = $dbh->prepare("SELECT * FROM summary_table ORDER BY skill DESC LIMIT ?, 1");

my $event_count = 0;
 

print "\n\n-----------------------------------------\n";
print "Welcome to the NS:CO Stats Parser\n";
print "-------------[t e a m - m i r a g e]-----\n";
print "created by Manfred 'defcon-X' Nerurkar\n";
print "       and Lord of Shadows\n";
print "\n";
print "special thanks to LostCause\n";
print "Stats Version: $version\n";
print "Req. NS:CO Version: $nscoversion\n";
print "-----------------------------------------\n";
print "if there are problems email us at defcon-x\@ns-co.net\n";
print "-----[www.team-mirage.net]---------------\n\n\n";

open (PIPE, "< $logpipe") || die "Could not open $logpipe for reading.";
        while (1) {
           while (<PIPE>) {
              my @time = localtime(time);
              my $unix_time = time;
              my $year = $time[5] + 1900;
              my $month = sprintf ("%02d", $time[4]+1);
              my $day = sprintf ("%02d", $time[3]);
              my $hour = sprintf ("%02d", $time[2]);
              
              $team[1022]=3;

              if ($_ =~m/ClientDisconnect: (\d+)$/) {
                $team[$1]=0;
                $player = &cleanup($1,30);
                $words = "Client $player Connecting\n";
                $sth = $dbh->prepare("INSERT INTO discussion_table (player,words,count) VALUES ('($player)','$words','$event_count')");
                $sth->execute(); 
                $event_count++;
              }

              elsif ($_ =~m/InitGame: \\(.+)$/) {
                %serverinfo = split(/\\/, $1);
                foreach $key (keys %serverinfo) {
                  if ($key) {
                    $value=$serverinfo{$key};

                    if ( $key eq "mapname" ) {
                      &checkdb("*", "maps_table", "name", $value, 'name');
                      if (!$old) {
                        $sth=$dbh->prepare("INSERT INTO maps_table (name) VALUES (?)");
                        $sth->execute($value);
                        $sth = $dbh->prepare("UPDATE maps_table SET value = 1 WHERE name = '$value'");
                        $sth->execute();
                      } else {
                        $sth = $dbh->prepare("UPDATE maps_table SET value = value+1 WHERE name = '$value'");
                        $sth->execute();
                      }
                      undef $old;
                    } else {
                      &checkdb("*", "server_table", "name", $key, 'name');
                      if (!$old) {
                        $sth=$dbh->prepare("INSERT INTO server_table (name) VALUES (?)");
                        $sth->execute($key);
                        $sth = $dbh->prepare("UPDATE server_table SET value = '$value' WHERE name = '$key'");
                        $sth->execute();
                      } else {
                        $sth = $dbh->prepare("UPDATE server_table SET value = '$value' WHERE name = '$key'");
                        $sth->execute();
                      }
                      undef $old;
                    }
                  }
                }
                undef @client;
                print "InitGame $serverinfo{mapname}\n";
              }

              elsif ($_ =~m/ClientConnect: (\d+)$/) {
                 $team[$1]=0;
                 $player = &cleanup($1,30);
                 $words = "Client $player Connecting\n";
                 $sth = $dbh->prepare("INSERT INTO discussion_table (player,words,count) VALUES ('($player)','$words','$event_count')");
                 $sth->execute(); 
                 $event_count++;
              }
 
              elsif ($_ =~m/ClientUserinfoChanged: (\d+) n\\(.+)\\t\\(\d+)\\model\\\w_medium\/(.+)\\\w\d\\.+$/) {
                 $player = &cleanup($2,30);
                 $model = &cleanup($4,100);
                 $html=$2;
                 $html=~s/\;//g;
                 $html=~s/\'//g;
                 $html=~s/\\//g;
                 $html= substr($html, 0, 30);
                 $team[$1]=$3;
                 $client[$1]="$player";
                 $sth = $dbh->prepare("UPDATE summary_table SET model = '$model', html = '$html' WHERE player = '$player'");
                 $sth->execute();
                 } 
 
             elsif ($_ =~m/\d+:\d{2}\s(.+) planted the c4$/ ) { 
                $player = &cleanup($1,30);  
                $sth = $dbh->prepare("UPDATE summary_table SET skill = skill + 100,c4 = c4+1 WHERE player = '$player'");
                $sth->execute();
              }

             elsif ($_ =~m/\d+:\d{2}\s?(.+) defused the c4$/) {
               $player = &cleanup($1,30);
               #   print "------> '$player'       defused the c4\n";
               $sth = $dbh->prepare("UPDATE summary_table SET skill = skill + 150,c4_defused = c4_defused+1 WHERE player = '$player'");
               $sth->execute();
               }
                           #1468:000 spawned as VIP
             elsif ($_ =~m/\d+:\d{2}\s?(.+) spawned as VIP$/)
                  {
                      $player = &cleanup($1,30);
                   #   print "------> '$player'        spawned as VIP\n";
                      $sth = $dbh->prepare("UPDATE summary_table SET skill = skill + 25,vip = vip+1 WHERE player = '$player'");
                      $sth->execute();
                  }
                           #5:57 0 escaped as vip
             elsif ($_ =~m/\d+:\d{2}\s?(.+) escaped as vip$/)
                  {
                     $player = &cleanup($1,30);
                  #   print "------> '$player'       escaped as vip\n";
                     $sth = $dbh->prepare("UPDATE summary_table SET skill = skill + 200,vip_lived = vip_lived+1 WHERE player = '$player'");
                     $sth->execute();
                  }

             elsif ($_ =~m/\d+:\d{2}\s?(.+) captured a briefcase$/) {
               $player = &cleanup($1,30);
               #   print "------> '$player'       captured a briefcase\n";
               $sth = $dbh->prepare("UPDATE summary_table SET skill = skill + 100,cases_capped = cases_capped+1 WHERE player = '$player'");
               $sth->execute();
             }

             elsif ($_ =~m/\d+:\d{2}\s?(.+) picked up a briefcase$/) {
               $player = &cleanup($1,30);
               #    print "------> '$player'       picked up a briefcase\n";
               $sth = $dbh->prepare("UPDATE summary_table SET skill = skill + 25,cases = cases+1 WHERE player = '$player'");
               $sth->execute();
             }

             elsif ($_ =~m/\d+:\d{2}\s?(.+) captured assault field (\d+)$/) {
               $player = &cleanup($1,30);
               #     print "------> '$player'       captured the assaultfield $2\n";
               $sth = $dbh->prepare("UPDATE summary_table SET skill = skill + 150,fields_capped = fields_capped+1 WHERE player = '$player'");
               $sth->execute();
             }


             elsif ($_ =~m/ROUND: (.+) won.$/) {
               $winner=&cleanup($1,50);
               &checkdb("*", "server_table", "name", $winner, "name");
               # set first entry
                 if (!$old) {
                   $sth=$dbh->prepare("INSERT INTO server_table (name) VALUES (?)");
                   $sth->execute($winner);
                   $sth = $dbh->prepare("UPDATE server_table SET value = 1 WHERE name = '$winner'");
                   $sth->execute();
                 } else {
                   # add one point to the winning team in the database
                   $sth = $dbh->prepare("UPDATE server_table SET value = value+1 WHERE name = '$winner'");
                   $sth->execute();
                 }
               undef $old;
             }

             #        13214:5xp: 120  ping: 75  client: 4 ^4-^7reta^4.^7Bl^4u^7tengel^4-^7    
             elsif ($_ =~m/xp: (\d+)  ping: (\d+)  client: (\d+) (.+)$/) {
               $xp=$1;
               $ping=$2;
               # $clientnum=$3;
               $player = &cleanup($4,30);  
                                                      
               $sth = $dbh->prepare("UPDATE summary_table SET ping = ping+$ping, pingcount = pingcount+1 WHERE player = '$player'");
               $sth->execute();
             }
              
             # gave 5 xp to real.BenB[TM] shots: 66 hits: 99
             elsif ( $_ =~m/gave (\d+) xp to (.+) shots: (\d+) hits: (\d+)$/ ) {              
               $xp=$1;
               $player = &cleanup($2,30);
               $shots = $3;
               $hits = $4;
               #  print "gave $xp xp to $player ($shots / $hits)\n";
               $sth = $dbh->prepare("UPDATE summary_table SET xp = xp+$xp, shots = shots+$shots, hits = hits+$hits, rounds = rounds+1  WHERE player = '$player'");
               $sth->execute();
             }
                
             elsif ($_ =~m/say: (.+): (.+)\n$/) {
               $player = &cleanup($1,30);
               $words = &cleanup($2,200);
               #print "$player: $words\n";
               if (  int(rand(10))  >= 5 ) {
                 $sth = $dbh->prepare("UPDATE summary_table SET words = '$words', wordcount = wordcount+1 WHERE player = '$player'");
                 $sth->execute();
               }
                  
               # eventcounter
               $sth = $dbh->prepare("INSERT INTO discussion_table (player,words,count) VALUES ('$player','$words','$event_count')");
               $sth->execute(); 
               $sth = $dbh->prepare("INSERT INTO say_table (player,words,postdate) VALUES ('$player','$words','".time()."')");
               $sth->execute();
               $event_count++;
             }
                
             elsif ($_ =~m/sayradio: (.+): (.+)\n$/) {
               $player = &cleanup($1,30);  
               $words = &cleanup($2,200);
               $sth = $dbh->prepare("UPDATE summary_table SET radiocount = radiocount+1 WHERE player = '$player'");
               $sth->execute();
               $sth = $dbh->prepare("INSERT INTO discussion_table (player,words,count) VALUES ('{$player}','$words','$event_count')");
               $sth->execute(); 
               $event_count++;
             }
                
             elsif ($_ =~m/sayteam: (.+): (.+)\n$/) {
               $player = &cleanup($1,30);  
               $words = &cleanup($2,200);
               $sth = $dbh->prepare("UPDATE summary_table SET teamcount = teamcount+1 WHERE player = '$player'");
               $sth->execute();
               $sth = $dbh->prepare("INSERT INTO discussion_table (player,words,count) VALUES ('($player)','$words','$event_count')");
               $sth->execute(); 
               $event_count++;
             }
                 
  
             elsif ($_ =~m/Kill: (\d+) (\d+) \d+: (.+) killed (.+) by (\d+)$/) {
               $killer_num=$1;
               $killee_num=$2;
               $killer = &cleanup($3,30);
               $killee = &cleanup($4,30);
               $weapon=$5;
               if (($killer_num==1022) || ($killee_num==1022)) {
                 next;
               }
                                     if ($weapon eq "0") {$weapon = "WP_NONE";} 
                                  elsif ($weapon eq "1") {$weapon = "WP_KHURKURI";} 
                                  elsif ($weapon eq "2") {$weapon = "WP_SEALKNIFE";} 
                                  elsif ($weapon eq "3") {$weapon = "WP_C4";} 
                                  elsif ($weapon eq "4") {$weapon = "WP_GRENADE";} 
                                  elsif ($weapon eq "5") {$weapon = "WP_FLASHBANG";} 
                                  elsif ($weapon eq "6") {$weapon = "WP_MK23";} 
                                  elsif ($weapon eq "7") {$weapon = "WP_GLOCK";} 
                                  elsif ($weapon eq "8") {$weapon = "WP_SW40T";} 
                                  elsif ($weapon eq "9") {$weapon = "WP_P9S";} 
                                  elsif ($weapon eq "10") {$weapon = "WP_DEAGLE";}
                                  elsif ($weapon eq "11") {$weapon = "WP_SW629";} 
                                  elsif ($weapon eq "12") {$weapon = "WP_PDW";} 
                                  elsif ($weapon eq "13") {$weapon = "WP_MAC10";} 
                                  elsif ($weapon eq "14") {$weapon = "WP_MP5";} 
                                  elsif ($weapon eq "16") {$weapon = "WP_AK47";} 
                                  elsif ($weapon eq "17") {$weapon = "WP_M4";} 
                                  elsif ($weapon eq "18") {$weapon = "WP_PSG1";} 
                                  elsif ($weapon eq "19") {$weapon = "WP_MACMILLAN";} 
                                  elsif ($weapon eq "20") {$weapon = "WP_870";} 
                                  elsif ($weapon eq "21") {$weapon = "WP_M590";} 
                                  elsif ($weapon eq "22") {$weapon = "WP_SPAS15";} 
                                  elsif ($weapon eq "23") {$weapon = "WP_M14";} 
                                  elsif ($weapon eq "24") {$weapon = "WP_M249";} 
                                  else {$weapon = "WP_NONE";}
               print "$killer \[team $team[$killer_num]\] killed $killee \[team $team[$killee_num]\] with $weapon\n";

               #print "Read killee's info...\n";
               $select_player->execute($killee);
               while ($pointer = $select_player->fetchrow_hashref()) {
                 $killee_skill = $pointer->{'skill'};
                 $killee_deaths = $pointer->{'deaths'};
               }
  
               if (!$killee_skill) {
                 $new_player->execute($killee, 1000);
                 $killee_skill = 1000;
                 $killee_deaths = 0;
                 #print "Added new player ($killee) to summary_table...\n";
               }
  
               #print "Read killer's info...\n";
               $select_player->execute($killer);
               while ($pointer = $select_player->fetchrow_hashref()) {
                 $killer_skill = $pointer->{'skill'};
                 $killer_kills = $pointer->{'kills'};
                 $weapon_kills = $pointer->{"$weapon"};
               }
  
               if (!$killer_skill) {
                 $new_player->execute($killer, 1000);
                 $killer_skill = 1000;
                 $weapon_kills=0;
                 $killer_kills=0;
                 #print "Added new player ($killer) to summary_table...\n";
               }
    
               if ($team[$killer_num]==$team[$killee_num]) {
                 $sth = $dbh->prepare("UPDATE summary_table SET tked = tked + 1 WHERE player = '$killee'");
                 $sth->execute();
                 $sth = $dbh->prepare("UPDATE summary_table SET tks = tks + 1 WHERE player = '$killer'");
                 $sth->execute();
                 $skill_change=10;
                 $killer_skill-=$skill_change;
               }
               elsif ($killer_num==1022) {
                 $skill_change=10;
                 $killer_skill-=$skill_change;
                 $sth = $dbh->prepare("UPDATE summary_table SET suicides = suicides + 1, deaths = deaths + 1 WHERE player = '$killee'");
                 $sth->execute();
               } else {
                 $skill_change=(($killee_skill/$killer_skill)*10);
                 $skill_change=sprintf("%d", $skill_change);
                 $skill_change=0 if ($skill_change < 0);
                 $skill_change=500 if ($skill_change > 500);
                 $killer_skill=$skill_change+$killer_skill;
                 $killee_skill=$killee_skill-$skill_change;
                 $killee_deaths++;
                 $killer_kills++;
                 $weapon_kills++;
                 $select_player_detailed->execute($killer,$killee);
                                        
                 ###
                 ### favorite victim counting
                 ###                                    
                 $count = 0;
                     
                 while ($pointer = $select_player_detailed->fetchrow_hashref()) {
                   $count = $pointer->{'count'};  
                 }
                 
                 if ( $killer ne $killee ) {
                   if ( $count <= 0 ) {
                     $count = 1;
                 #                if ( $killer eq "[Hogs]HanMeGitarren" )
                 #                {
                 #                        print "CREATED player $killer and $killee with count $count [killer kills $killer_kills]\n";
                 #                } 
                     $sth=$dbh->prepare("INSERT INTO detailed_table (killer,killee,count) VALUES ( \"$killer\", \"$killee\" , \"$count\" )");
                     $sth->execute();
                   } else {
                     $count = $count + 1; 
                 #   if ( $killer eq "[Hogs]HanMeGitarren" ) {
                 #     print "found player $killer and $killee with count $count [killer kills $killer_kills]\n";
                 #   }
                     $sth = $dbh->prepare("UPDATE detailed_table SET count = '$count' WHERE killer = '$killer' && killee = '$killee'");
                     $sth->execute(); 
                   }
                 }
               }#end else statement (if (you killed spec) elseif (you killed team) else (a real frag)
             $sth = $dbh->prepare("UPDATE summary_table SET skill = '$killer_skill',kills = '$killer_kills',$weapon = '$weapon_kills' WHERE player = '$killer'");
             $sth->execute();
             $sth = $dbh->prepare("UPDATE summary_table SET skill = '$killee_skill',deaths = '$killee_deaths' WHERE player = '$killee'");
             $sth->execute();
  
             $sth = $dbh->prepare("INSERT INTO discussion_table (player,words,count) VALUES ('($killer)','$killer killed $killee with $weapon_kills','$event_count')");
             $sth->execute(); 
             $event_count++;
                                  
             #print "Event processed...\n";
             undef $skill_change;
             undef $killer_skill;
             undef $killee_skill;
             undef $killee_deaths;
             undef $killer_kills;
             }#end KILL: search

             ###
             ###  RCON - I added this for the heck of it, code was on my hd.
             ###
             if ($rstat > 0) {
               use SOCKET;
               if ($_ =~m/say: (.+): (.+)\n$/) {
                 $player = &cleanup($1,30);
                 $words = &cleanup($2,200);
                 print "$player: $words\n";
                 if ($words =~m/!stats/){
                   if ($words =~m/!stats (\d+)/) {
                     $rank=$1-1;
                     $select_rank->execute($rank);
                     while ($pointer = $select_rank->fetchrow_hashref()) {
                     $n = $pointer->{'html'};
                     $s = $pointer->{'skill'};
                     $k = $pointer->{'kills'};
                     $d = $pointer->{'deaths'};
                   }
                   if ($s) {
                     $cmd="Stats: $n \^7$k/$d $s";
                   } else {
                     $cmd="Stats: Rank $1 not found.";
                   }
                 }
  
                 elsif ($words =~m/!stats (.+)/) {
                   $name = &cleanup($1,30);
                   $select_player->execute($name);
                   while ($pointer = $select_player->fetchrow_hashref()) {
                     $s = $pointer->{'skill'};
                     $k = $pointer->{'kills'};
                     $d = $pointer->{'deaths'};
                   }
                   if ($s) {
                     $cmd="Stats: $1 \^7$k/$d $s";
                   } else {
                     $cmd="Stats: Player $1 not found.";
                   }
                 } else {
                   $select_player->execute($player);
                   while ($pointer = $select_player->fetchrow_hashref()) {
                     $s = $pointer->{'skill'};
                     $k = $pointer->{'kills'};
                     $d = $pointer->{'deaths'};
                   }
                   if ($s) {
                     $cmd="Stats: $1 \^7$k/$d $s";
                   } else {
                     $cmd="Stats: Player $1 not found.";
                   }
                 }
                 &rcon($cmd) if $cmd;
                 undef $n;
                 undef $s;
                 undef $k;
                 undef $d;
                 undef $cmd;
               }
             }
           }#end while <pipe>
        sleep 1;
        }#end while (1)
$dbh->disconnect;
exit;
}#end open

sub cleanup{
  ($data, $length) = @_;
  $data =~s/\^\S//g;
  $data =~s/\'//g;
  $data =~s/\\//g;
  $data = substr($data, 0, $length);
}

sub checkdb{
($column, $table, $rowname, $row, $check) = @_;
  $statement = "SELECT $column FROM $table WHERE $rowname = ?";
  $sth = $dbh->prepare($statement);
  $sth->execute($row);
  while ($pointer = $sth->fetchrow_hashref()) {
    $old = $pointer->{"$check"};
  }
}

sub rcon{
($cmd) = @_;
socket(RCON, PF_INET, SOCK_DGRAM, getprotobyname('udp')) || die $!;
  setsockopt(RCON, SOL_SOCKET, SO_REUSEADDR, 1) || dir $!;
  $server = sockaddr_in ($q3port, inet_aton($q3server));
  connect(RCON, $server) || die $!;
    send(RCON, "\xFF\xFF\xFF\xFFrcon " . "$q3rcon" . " $cmd\n\0", 0, $server);
    recv(RCON, $reply, 8192, 0);
    $reply =~ s/^\xFF\xFF\xFF\xFF//;  
  close (RCON);
  print "$reply";
  sleep 1;
}