CREATE TABLE detailed_table (
  killer varchar(30) NOT NULL default '',
  killee varchar(30) NOT NULL default '',
  weapon varchar(30) NOT NULL default '',
  skillp int(5) NOT NULL default '0',
  time int(15) NOT NULL default '0',
  count int(5) NOT NULL default '0',
  KEY killer (killer),
  KEY time (time)
) TYPE=MyISAM;

CREATE TABLE summary_table (
  player varchar(30) NOT NULL default 'UnnamedSoldier',
  html varchar(50) NOT NULL default 'UnnamedSoldier', 
  kills int(5) NOT NULL default '0',
  tks int(5) NOT NULL default '0',
  tked int(5) NOT NULL default '0',
  suicides int(5) NOT NULL default '0',
  xp int(5) NOT NULL default '0',
  rounds int(5) NOT NULL default '0',
  deaths int(5) NOT NULL default '0',
  fields_capped int(5) NOT NULL default '0',
  cases int(5) NOT NULL default '0',
  cases_capped int(5) NOT NULL default '0',
  c4 int(5) NOT NULL default '0',
  c4_defused int(5) NOT NULL default '0',
  vip int(5) NOT NULL default '0',
  vip_lived int(5) NOT NULL default '0',
  skill int(5) NOT NULL default '0',
  radiocount int(5) NOT NULL default '0',
  teamcount int(5) NOT NULL default '0',
  wordcount int(5) NOT NULL default '0',
  ping int(5) NOT NULL default '0',
  pingcount int(5) NOT NULL default '0',
  words varchar(200) NOT NULL default 'The words of wise men are heard in quiet more than the cry of him that rule among fools.',
  model varchar(100) NOT NULL default 's_medium/chris_camo',
  WP_NONE int(5) NOT NULL default '0',
  WP_KHURKURI int(5) NOT NULL default '0',
  WP_SEALKNIFE int(5) NOT NULL default '0',
  WP_C4 int(5) NOT NULL default '0',
  WP_GRENADE int(5) NOT NULL default '0',
  WP_FLASHBANG int(5) NOT NULL default '0',
  WP_MK23 int(5) NOT NULL default '0',
  WP_GLOCK int(5) NOT NULL default '0',
  WP_SW40T int(5) NOT NULL default '0',
  WP_P9S int(5) NOT NULL default '0',
  WP_DEAGLE int(5) NOT NULL default '0',
  WP_SW629 int(5) NOT NULL default '0',
  WP_PDW int(5) NOT NULL default '0',
  WP_MAC10 int(5) NOT NULL default '0',
  WP_MP5 int(5) NOT NULL default '0',
  WP_AK47 int(5) NOT NULL default '0',
  WP_M4 int(5) NOT NULL default '0',
  WP_M14 int(5) NOT NULL default '0',
  WP_PSG1 int(5) NOT NULL default '0',
  WP_MACMILLAN int(5) NOT NULL default '0',
  WP_870 int(5) NOT NULL default '0',
  WP_M590 int(5) NOT NULL default '0',
  WP_SPAS15 int(5) NOT NULL default '0',
  WP_M249 int(5) NOT NULL default '0',
  KEY player (player),
  KEY skill (skill)
) TYPE=MyISAM;

CREATE TABLE server_table (
  name varchar(100) NOT NULL default 'name',
  value varchar(100) NOT NULL default '0',
  KEY name (name)
) TYPE=MyISAM;

CREATE TABLE maps_table (
  name varchar(100) NOT NULL default 'name',
  value int(100) NOT NULL default '0',
  KEY name (name)
) TYPE=MyISAM;

CREATE TABLE permanent_table (
  name varchar(100) NOT NULL default 'name',
  value varchar(100) NOT NULL default '0',
  KEY name (name)
) TYPE=MyISAM;

CREATE TABLE comment_table (
  player varchar(30) NOT NULL default '',
  comment longtext NOT NULL default '',
  writer varchar(30) NOT NULL default '',
  writermail varchar(30) NOT NULL default 'unknown@bee.com',
  writerip varchar(30) NOT NULL default '255.255.255.255',
  count int(5) NOT NULL default '0',
  KEY player (player),
  KEY writer (writer)
) TYPE=MyISAM;